Index: CONFIG/UNIFORM/v6/IPSLCM6CHT/GENERAL/DRIVER/orchidee.driver
===================================================================
--- CONFIG/UNIFORM/v6/IPSLCM6CHT/GENERAL/DRIVER/orchidee.driver	(revision 3687)
+++ CONFIG/UNIFORM/v6/IPSLCM6CHT/GENERAL/DRIVER/orchidee.driver	(revision 3688)
@@ -1,4 +1,4 @@
 #!/bin/ksh
-#D- Driver du script pour ORCHIDEE
+## Driver for the component SRF corresponding to the sechiba part of ORCHIDEE
 #-----------------------------------------------------------------
 function SRF_Initialize
@@ -6,19 +6,11 @@
     IGCM_debug_PushStack "SRF_Initialize"
 
-    RESOL_SRF=ALL
-
-    for frequency in ${config_SRF_WriteFrequency} ; do
-        case ${frequency} in
-            HF|hf) SRF_ok_hf=y ;;
-        esac
-    done
-
     ##- Define variable DefSuffix set in orchidee.card
-    ##  This variable is used in orchidee.card to choose 
-    ##  parameter file(orchidee.def_DefSuffix). 
+    ##  This variable is used in orchidee.card to choose
+    ##  parameter file(orchidee.def_DefSuffix).
     if [ ! X${orchidee_UserChoices_DefSuffix} = X ] ; then
-	DefSuffix=${orchidee_UserChoices_DefSuffix}
+        DefSuffix=${orchidee_UserChoices_DefSuffix}
     else
-	DefSuffix=Choi
+        DefSuffix=Choi
     fi
 
@@ -31,162 +23,120 @@
     IGCM_debug_PushStack "SRF_Update"
 
+    ## 1. Modifications in orchidee.def parameter file
+
     # Activate STOMATE if the compontent SBG=stomate is set in config.card
     if [ X${config_ListOfComponents_SBG} = Xstomate ] ; then
-	IGCM_comp_modifyDefFile blocker orchidee.def STOMATE_OK_STOMATE y
+	# Activate stomate in orchidee.def
+        IGCM_comp_modifyDefFile blocker orchidee.def STOMATE_OK_STOMATE y
     else
-	IGCM_comp_modifyDefFile blocker orchidee.def STOMATE_OK_STOMATE n
+	# Deactivate stomate in orchidee.def
+        IGCM_comp_modifyDefFile blocker orchidee.def STOMATE_OK_STOMATE n
+	# Deactivate output files for stomate
+	IGCM_comp_modifyXmlFile nonblocker file_def_orchidee.xml stomate1 enabled .FALSE.
+	IGCM_comp_modifyXmlFile nonblocker file_def_orchidee.xml stomate1 output_level 0
+	IGCM_comp_modifyXmlFile nonblocker file_def_orchidee.xml stomate1 output_freq 1mo
+        IGCM_comp_modifyXmlFile nonblocker file_def_orchidee.xml stomate2 enabled .FALSE.
+	IGCM_comp_modifyXmlFile nonblocker file_def_orchidee.xml stomate2 output_level 0
+	IGCM_comp_modifyXmlFile nonblocker file_def_orchidee.xml stomate2 output_freq 1mo
     fi
 
-    typeset SECHIBA_WRITE_STEP
-
-    if [ X${orchidee_UserChoices_XIOS} = Xy ] ; then
-	IGCM_comp_modifyXmlFile force file_def_orchidee.xml sechiba1 enabled .FALSE. 
-	IGCM_comp_modifyXmlFile force file_def_orchidee.xml sechiba2 enabled .FALSE. 
-	IGCM_comp_modifyDefFile nonblocker orchidee.def XIOS_ORCHIDEE_OK y
+    # Define in orchidee.def if restart file should be used
+    if ( [ ${CumulPeriod} -ne 1 ] || [ "${config_SRF_Restart}" != "n" ] ) ; then
+        IGCM_comp_modifyDefFile blocker orchidee.def SECHIBA_restart_in sechiba_rest_in.nc
     else
-	IGCM_comp_modifyDefFile nonblocker orchidee.def XIOS_ORCHIDEE_OK n
-    fi    
-
-    SRF_WriteFrequency=$( echo ${config_SRF_WriteFrequency} | sed -e 's/\([0-9]*[yYmMdDs]\).*/\1/' ) 
-    case ${SRF_WriteFrequency} in
-	*Y|*y) 
-	    WriteInYears=$( echo ${SRF_WriteFrequency} | awk -F '[yY]' '{print $1}' )
-	    PeriodLengthInYears=$( echo ${config_UserChoices_PeriodLength} | awk -F '[yY]' '{print $1}' )
-	    (( SECHIBA_WRITE_STEP = PeriodLengthInDays * WriteInYears / PeriodLengthInYears * 86400 )) 
-	    if [ X${orchidee_UserChoices_XIOS} = Xy ] ; then
-		IGCM_comp_modifyXmlFile force file_def_orchidee.xml sechiba1 enabled .TRUE. 
-		IGCM_comp_modifyXmlFile force file_def_orchidee.xml sechiba1 output_freq ${WriteInYears}y
-		IGCM_comp_modifyXmlFile force file_def_orchidee.xml sechiba1 name sechiba_history 
-	    fi
-	    ;;
-	1M)
-	    if [ X${orchidee_UserChoices_XIOS} = Xy ] ; then
-		IGCM_comp_modifyXmlFile force file_def_orchidee.xml sechiba1 enabled .TRUE. 
-		IGCM_comp_modifyXmlFile force file_def_orchidee.xml sechiba1 output_freq 1mo
-		IGCM_comp_modifyXmlFile force file_def_orchidee.xml sechiba1 name sechiba_history 
-	    fi
-	    case ${config_UserChoices_PeriodLength} in
-	    *Y|*y)
-		SECHIBA_WRITE_STEP=-1.
-		;;
-	    *M|*m)
-		SECHIBA_WRITE_STEP=-1.
-		;;
-	    *)
-		(( SECHIBA_WRITE_STEP = $( IGCM_date_DaysInMonth $year $month ) * 86400 ))
-		;;
-	    esac
-	    ;;
-	*M|*m) 
-	    WriteInMonths=$( echo ${SRF_WriteFrequency} | awk -F '[mM]' '{print $1}' )
-	    if [ X${orchidee_UserChoices_XIOS} = Xy ] ; then
-		IGCM_comp_modifyXmlFile force file_def_orchidee.xml sechiba1 enabled .TRUE. 
-		IGCM_comp_modifyXmlFile force file_def_orchidee.xml sechiba1 output_freq ${WriteInMonths}mo
-		IGCM_comp_modifyXmlFile force file_def_orchidee.xml sechiba1 name sechiba_history 
-	    fi
-	    case ${config_UserChoices_PeriodLength} in
-	    *Y|*y)
-		PeriodLengthInYears=$( echo ${config_UserChoices_PeriodLength} | awk -F '[yY]' '{print $1}' )
-		(( SECHIBA_WRITE_STEP = PeriodLengthInDays * 86400 / PeriodLengthInYears / 12  ))
-		;;
-	    *M|*m)
-		PeriodLengthInMonths=$( echo ${config_UserChoices_PeriodLength} | awk -F '[mM]' '{print $1}' )
-		(( SECHIBA_WRITE_STEP = PeriodLengthInDays * WriteInMonths  * 86400 / PeriodLengthInMonths  ))
-		;;
-	    *)
-		(( SECHIBA_WRITE_STEP = $( IGCM_date_DaysInMonth $year $month ) * 86400 ))
-		if [ X${orchidee_UserChoices_XIOS} = Xy ] ; then
-		    IGCM_comp_modifyXmlFile force file_def_orchidee.xml sechiba1 enabled .TRUE. 
-		    IGCM_comp_modifyXmlFile force file_def_orchidee.xml sechiba1 output_freq ${SECHIBA_WRITE_STEP}s
-		    IGCM_comp_modifyXmlFile force file_def_orchidee.xml sechiba1 name sechiba_history
-		fi
-		;;
-	    esac
-	    ;;
-	5D|5d) 
-	    if [ X${orchidee_UserChoices_XIOS} = Xy ] ; then
-		IGCM_comp_modifyXmlFile force file_def_orchidee.xml sechiba1 enabled .TRUE. 
-		IGCM_comp_modifyXmlFile force file_def_orchidee.xml sechiba1 output_freq 5d
-		IGCM_comp_modifyXmlFile force file_def_orchidee.xml sechiba1 name sechiba_history 
-	    fi
-	    (( SECHIBA_WRITE_STEP = 5 * 86400 )) 
-	    ;;
-	1D|1d) 
-	    if [ X${orchidee_UserChoices_XIOS} = Xy ] ; then
-		IGCM_comp_modifyXmlFile force file_def_orchidee.xml sechiba1 enabled .TRUE. 
-		IGCM_comp_modifyXmlFile force file_def_orchidee.xml sechiba1 output_freq 1d
-		IGCM_comp_modifyXmlFile force file_def_orchidee.xml sechiba1 name sechiba_history 
-	    fi
-	    (( SECHIBA_WRITE_STEP = 86400 )) 
-	    ;;
-	*s)
-	    WriteInSeconds=$( echo ${SRF_WriteFrequency} | awk -F '[s]' '{print $1}' )
-	    if [ X${orchidee_UserChoices_XIOS} = Xy ] ; then
-		IGCM_comp_modifyXmlFile force file_def_orchidee.xml sechiba1 enabled .TRUE. 
-		IGCM_comp_modifyXmlFile force file_def_orchidee.xml sechiba1 output_freq ${WriteInSeconds}s
-		IGCM_comp_modifyXmlFile force file_def_orchidee.xml sechiba1 name sechiba_history 
-	    fi
-	    (( SECHIBA_WRITE_STEP = WriteInSeconds )) ;;
-	*) 
-	    IGCM_debug_Exit "SRF_Update " ${SRF_WriteFrequency} " invalid WriteFrequency : choose in 1Y, 1M, 5D, 1D." 
-	    IGCM_debug_Verif_Exit ;;
-    esac
-
-#Use of XIOS ouputs only
-
-    if [ X${orchidee_UserChoices_XIOS} = Xy ] ; then
-	(( SECHIBA_WRITE_STEP = 0 ))
-    fi
-    IGCM_comp_modifyDefFile nonblocker orchidee.def WRITE_STEP ${SECHIBA_WRITE_STEP}
-    IGCM_comp_modifyDefFile nonblocker orchidee.def SECHIBA_HISTLEVEL ${orchidee_UserChoices_sechiba_LEVEL}
-
-    # Outputs HF in HISTFILE2 if required
-    if [ X${SRF_ok_hf} = Xy ] ; then
-	IGCM_comp_modifyDefFile nonblocker orchidee.def SECHIBA_HISTFILE2 y
-	if [ X${orchidee_UserChoices_XIOS} = Xy ] ; then
-	    IGCM_comp_modifyXmlFile force file_def_orchidee.xml sechiba2 enabled .TRUE. 
-	    IGCM_comp_modifyXmlFile force file_def_orchidee.xml sechiba2 output_freq 10800s
-	    IGCM_comp_modifyXmlFile force file_def_orchidee.xml sechiba2 name sechiba_out_2
-	fi
-    else
-	IGCM_comp_modifyDefFile nonblocker orchidee.def SECHIBA_HISTFILE2 n
-    fi
-    IGCM_comp_modifyDefFile nonblocker orchidee.def SECHIBA_HISTLEVEL2 1
-    IGCM_comp_modifyDefFile nonblocker orchidee.def WRITE_STEP2 10800.0
-
-    if ( [ ${CumulPeriod} -ne 1 ] || [ "${config_SRF_Restart}" != "n" ] ) ; then
-	IGCM_comp_modifyDefFile blocker orchidee.def SECHIBA_restart_in sechiba_rest_in.nc
-    else
-	IGCM_comp_modifyDefFile blocker orchidee.def SECHIBA_restart_in NONE
+        IGCM_comp_modifyDefFile blocker orchidee.def SECHIBA_restart_in NONE
     fi
 
-# Modify in orchidee.def VEGET_UPDATE and LAND_COVER_CHANGE if they are set in orchidee.card section UserChoices
-    if [ ! X${orchidee_UserChoices_VEGET_UPDATE} = X ] ; then
-	IGCM_comp_modifyDefFile nonblocker orchidee.def VEGET_UPDATE   ${orchidee_UserChoices_VEGET_UPDATE}
-    else
-	IGCM_comp_modifyDefFile nonblocker orchidee.def VEGET_UPDATE 0Y
-    fi
-    if [ ! X${orchidee_UserChoices_LAND_COVER_CHANGE} = X ] ; then
-	IGCM_comp_modifyDefFile nonblocker orchidee.def LAND_COVER_CHANGE ${orchidee_UserChoices_LAND_COVER_CHANGE}
-    else
-	IGCM_comp_modifyDefFile nonblocker orchidee.def LAND_COVER_CHANGE n
+    # Set VEGET_UPDATE=1Y in orchidee.def if VEGET_UPDATE_at_start=y in orchidee.card and if it is the first cumul periond (start of new simulation)
+    if [ X${orchidee_UserChoices_VEGET_UPDATE_at_start} = Xy ] && [ ${CumulPeriod} -eq 1 ] ; then
+        IGCM_comp_modifyDefFile nonblocker orchidee.def VEGET_UPDATE   1Y
     fi
 
-    #IGCM_sys_Cp ${RUN_DIR}/orchidee.def ${RUN_DIR}/run.def
-    #IGCM_sys_Put_Out ${RUN_DIR}/run.def ${R_SAVE}/${PREFIX}_run.def
+    # Modify in orchidee.def VEGET_UPDATE if it is set in orchidee.card section UserChoices
+    # Note: if the variable has been set by VEGET_UPDATE_at_start, this section will not overwrite it.
+    if [ ! X${orchidee_UserChoices_VEGET_UPDATE} = X ] ; then
+        IGCM_comp_modifyDefFile nonblocker orchidee.def VEGET_UPDATE   ${orchidee_UserChoices_VEGET_UPDATE}
+    else
+        IGCM_comp_modifyDefFile nonblocker orchidee.def VEGET_UPDATE 0Y
+    fi
 
-#Temporary way to fix bug on cimean variable
-    IGCM_comp_modifyXmlFile force field_def_orchidee.xml cimean enabled .FALSE. 
+    # Activate creation of river description file only for the first period
+    if [ ${CumulPeriod} -eq 1 ] ; then
+        IGCM_comp_modifyDefFile nonblocker orchidee.def RIVER_DESC y
+    else
+        IGCM_comp_modifyDefFile nonblocker orchidee.def RIVER_DESC n
+    fi
 
-    if [ X${orchidee_UserChoices_XIOS} = Xy ] ; then
+
+    ## 2. Mangement of output and modifications of related xml files
+    # Modify file_def_orchidee.xml file using settings from orchidee.card
+    # We here suppose that for each file, in orchidee.card UserChoices section, if the parameter 
+    # output_level_filename is set, then also output_freq_filename must be set. The existance of output_freq_filename will not be checked. 
+    # If output_level_filename=NONE or if it is not set, the corresponding file will be deactivated.
+    # Settings in config.card WriteFrequency are not used any more.
+    
+    if [ X${orchidee_UserChoices_output_level_sechiba_history} = X ] || [ X${orchidee_UserChoices_output_level_sechiba_history} = XNONE ] ; then
+	# output_level_sechiba_history is not set in orchidee.card or it is set to NONE.
+	# Deactivate the file.
+	IGCM_comp_modifyXmlFile nonblocker file_def_orchidee.xml sechiba1 enabled .FALSE.
+	IGCM_comp_modifyXmlFile nonblocker file_def_orchidee.xml sechiba1 output_level 0
+	IGCM_comp_modifyXmlFile nonblocker file_def_orchidee.xml sechiba1 output_freq 1mo
+    else
+	IGCM_comp_modifyXmlFile nonblocker file_def_orchidee.xml sechiba1 enabled      .TRUE.
+	IGCM_comp_modifyXmlFile nonblocker file_def_orchidee.xml sechiba1 output_level ${orchidee_UserChoices_output_level_sechiba_history}
+	IGCM_comp_modifyXmlFile nonblocker file_def_orchidee.xml sechiba1 output_freq  ${orchidee_UserChoices_output_freq_sechiba_history}
+    fi
+    
+    if [ X${orchidee_UserChoices_output_level_sechiba_out_2} = X ] || [ X${orchidee_UserChoices_output_level_sechiba_out_2} = XNONE ] ; then
+	# output_level_sechiba_out_2 is not set in orchidee.card or it is set to NONE.
+	# Deactivate the file.
+	IGCM_comp_modifyXmlFile nonblocker file_def_orchidee.xml sechiba2 enabled .FALSE.
+	IGCM_comp_modifyXmlFile nonblocker file_def_orchidee.xml sechiba2 output_level 0
+	IGCM_comp_modifyXmlFile nonblocker file_def_orchidee.xml sechiba2 output_freq 1mo
+    else
+	IGCM_comp_modifyXmlFile nonblocker file_def_orchidee.xml sechiba2 enabled      .TRUE.
+	IGCM_comp_modifyXmlFile nonblocker file_def_orchidee.xml sechiba2 output_level ${orchidee_UserChoices_output_level_sechiba_out_2}
+	IGCM_comp_modifyXmlFile nonblocker file_def_orchidee.xml sechiba2 output_freq  ${orchidee_UserChoices_output_freq_sechiba_out_2}
+    fi
+    
+    if [ X${orchidee_UserChoices_output_level_sechiba_history_4dim} = X ] || [ X${orchidee_UserChoices_output_level_sechiba_history_4dim} = XNONE ] ; then
+	# output_level_sechiba_history_4dim is not set in orchidee.card or it is set to NONE.
+	# Deactivate the file.
+	IGCM_comp_modifyXmlFile nonblocker file_def_orchidee.xml sechiba3 enabled .FALSE.
+	IGCM_comp_modifyXmlFile nonblocker file_def_orchidee.xml sechiba3 output_level 0
+	IGCM_comp_modifyXmlFile nonblocker file_def_orchidee.xml sechiba3 output_freq 1mo
+    else
+	IGCM_comp_modifyXmlFile nonblocker file_def_orchidee.xml sechiba3 enabled      .TRUE.
+	IGCM_comp_modifyXmlFile nonblocker file_def_orchidee.xml sechiba3 output_level ${orchidee_UserChoices_output_level_sechiba_history_4dim}
+	IGCM_comp_modifyXmlFile nonblocker file_def_orchidee.xml sechiba3 output_freq  ${orchidee_UserChoices_output_freq_sechiba_history_4dim}
+    fi
+        
+
     # Add include of orchidee context in iodef.xml
     # In iodef.xml add on next line after "COMPONENT CONTEXT"
     #  <context id="orchidee" src="./context_orchidee.xml"/>
-	echo '<context id="orchidee" src="./context_orchidee.xml"/>' > add.tmp
-	cp iodef.xml iodef.xml.tmp
-	sed -e "/COMPONENT CONTEXT/r add.tmp" \
-	    iodef.xml.tmp > iodef.xml
-	rm iodef.xml.tmp add.tmp
+    echo '<context id="orchidee" src="./context_orchidee.xml"/>' > add.tmp
+    if [ X"$( echo ${config_UserChoices_ExpType} | grep CMIP6 )" != "X" ] ; then
+	echo '<context id="orchidee" src="./ping_orchidee.xml"/>' >> add.tmp
+	echo '<context id="orchidee" src="./dr2xml_orchidee.xml"/>' >> add.tmp
     fi
+    cp iodef.xml iodef.xml.tmp
+    sed -e "/COMPONENT CONTEXT/r add.tmp" iodef.xml.tmp > iodef.xml
+    rm iodef.xml.tmp add.tmp
+
+    # Add LongName as global attribute in XIOS output files (if LongName is not empty)
+    if [ ! "X${config_UserChoices_LongName}" = "X" ] ; then
+	listfile=$(ls file_def*orchidee.xml)
+	echo "<variable id=\"LongName\" type=\"string\">${config_UserChoices_LongName}</variable>" > add.tmp
+	for file in ${listfile}
+	do
+	    cp ${file} ${file}.tmp
+	    sed -e "/<file id/r add.tmp" \
+		${file}.tmp > ${file}
+	    rm ${file}.tmp 
+	done 
+	rm add.tmp
+    fi
+
 
     IGCM_debug_PopStack "SRF_Update"
@@ -198,8 +148,4 @@
     IGCM_debug_PushStack "SRF_Finalize"
 
-    #IGCM_sys_Put_Out ${RUN_DIR}/used_run.def ${R_SAVE}/${PREFIX}_used_run.def
-
-    echo FINALIZE SRF !!!
-
     IGCM_debug_PopStack "SRF_Finalize"
 }
Index: CONFIG/UNIFORM/v6/IPSLCM6CHT/GENERAL/DRIVER/pisces.driver
===================================================================
--- CONFIG/UNIFORM/v6/IPSLCM6CHT/GENERAL/DRIVER/pisces.driver	(revision 3687)
+++ CONFIG/UNIFORM/v6/IPSLCM6CHT/GENERAL/DRIVER/pisces.driver	(revision 3688)
@@ -6,13 +6,8 @@
     IGCM_debug_PushStack "MBG_Initialize"
 
-# Local function to find namelists parameters
-supergrep () {
-    grep "^ *$1 *=" $2 | sed -e "s% *\!.*%%"
-}
+    # Local function to find parameters in LMDZ .def files
 
-# Local function to find parameters in LMDZ .def files
-
-lmdzgrep () {
-    grep $1 $2 |grep -v "#" | awk "-F=" '{print $2}'
+lmdzgrep2 () {
+     grep -w ${1} ${2} | grep -v "#"  | sed -e 's/=//g' -e 's/://g' -e 's/_AUTO_//' -e 's/DEFAULT//' | sed -e "s/${1}//" 
 }
 
@@ -22,14 +17,4 @@
     # nrsttr    control of the time step (0, 1 or 2)
     
-    ##--Variables used by PISCES --
- 
-    NAMELIST_TOP_CFG=${SUBMIT_DIR}/PARAM/namelist_top_${RESOL_OCE}_cfg
-    NAMELIST_PISCES_CFG=${SUBMIT_DIR}/PARAM/namelist_pisces_${RESOL_OCE}_cfg
-
-    PAT_TOP_LRSTTR=$( supergrep ln_rsttr          ${NAMELIST_TOP_CFG} )
-    PAT_TOP_NRSTTR=$( supergrep nn_rsttr          ${NAMELIST_TOP_CFG} )
-    PAT_PIS_ATCCO2=$( supergrep atcco2            ${NAMELIST_PISCES_CFG} )
-    PAT_PIS_LRIVER=$( supergrep ln_river          ${NAMELIST_PISCES_CFG} )
-
     IGCM_debug_PopStack "MBG_Initialize"
 }
@@ -40,20 +25,33 @@
     IGCM_debug_PushStack "MBG_Update"
 
+    ##--Write Frequency for iomput
+    ## Differents frequencies are allowed for MBG files
+
+    VT1D_ENABLE=".FALSE."
+    VT5D_ENABLE=".FALSE."
+    VT1M_ENABLE=".FALSE."
+    VT1Y_ENABLE=".FALSE."
+
+    for frequency in ${config_MBG_WriteFrequency} ; do
+        case ${frequency} in
+            ( 1D|1d ) VT1D_ENABLE=".TRUE." ;;
+            ( 5D|5d ) VT5D_ENABLE=".TRUE." ;;
+            ( 1M|1m ) VT1M_ENABLE=".TRUE." ;;
+            ( *[yY] ) VT1Y_ENABLE=".TRUE." ;;
+        esac
+    done
+
     ##-- Restart configuration
     if ( [ "${CumulPeriod}" -eq 1 ] && [ "${config_MBG_Restart}" = "n" ] ) ; then
 
         #echo "NO RESTART FOR TOP"
-        TOP_LRSTTR=.FALSE.
-        TOP_NRSTTR=0
-
-        PISCES_LRIVER=.FALSE.
+        TOP_LN_RSTR=.FALSE.
+        TOP_NN_RSTR=0
 
     elif ( [ "${CumulPeriod}" -eq 1 ] && [ "${config_MBG_Restart}" = "y" ] ) ; then
 
         #echo "RESTART TOP"
-        TOP_LRSTTR=.TRUE.
-        TOP_NRSTTR=0
-
-        PISCES_LRIVER=.TRUE.
+        TOP_LN_RSTR=.TRUE.
+        TOP_NN_RSTR=0
 
         # If we start from IPSLCM5* restart files.
@@ -65,8 +63,6 @@
 
         #echo "RESTART TOP"
-        TOP_LRSTTR=.TRUE.
-        TOP_NRSTTR=2
-
-        PISCES_LRIVER=.FALSE.
+        TOP_LN_RSTR=.TRUE.
+        TOP_NN_RSTR=2
 
     fi
@@ -81,6 +77,5 @@
     # update iodef.xml
 
-    echo 'Informations into iodef.xml : DBIO_ENABLE'
-    echo ${DBIO_ENABLE}
+    IGCM_debug_Print 1 " 'Informations into iodef.xml : DBIO_ENABLE : ${DBIO_ENABLE}"
 
     sed -e "s/<DBIO_ENABLE>/${DBIO_ENABLE}/" \
@@ -91,37 +86,43 @@
     ##-- CO2 forcing : update atcco2 value in namelist_pisces_cfg
     if [ "${pisces_UserChoices_CARBON_CYCLE}" = "y" ]; then
-       	# Special case for carbon cycle
+       	IGCM_debug_Print 1 "Special case for carbon cycle"
 	# Activate this case by putting CARBON_CYCLE=y in pisces.card section UserChoices
-	echo 'Update atcco2 in namelist_pisces_cfg with value from file co2.log'
+	IGCM_debug_Print 1  'Update atcco2 in namelist_pisces_cfg with value from file co2.log'
 	PathCO2log=${SUBMIT_DIR}
 	PreviousLinelog=$( tail -1 ${PathCO2log}/co2.log )
 	IPCC_PIS_CO2=$( echo "${PreviousLinelog[*]}" | gawk -F '|' '{gsub(" ",""); print $4}' )
-	sed -e "s%${PAT_PIS_ATCCO2}%          atcco2=${IPCC_PIS_CO2}%"             \
-	    namelist_pisces_cfg > namelist_pisces_cfg.tmp
-	IGCM_sys_Mv namelist_pisces_cfg.tmp namelist_pisces_cfg
+	IGCM_debug_Print 1 "IPCC_PIS_CO2 : ${IPCC_PIS_CO2} "
+	IGCM_comp_modifyNamelist force  namelist_pisces_cfg atcco2 ${IPCC_PIS_CO2}
     else
-	# Take same CO2 as for LMDZ, in parameter file config.def.
-	# ATM_Update is done before MBG_Update and therefor config.def file contains the correct value for CO2.
-	echo 'Update atcco2 in namelist_pisces_cfg with same value as for LMDZ'
-	LMDZ_CO2=$( lmdzgrep co2_ppm config.def )
-	sed -e "s%${PAT_PIS_ATCCO2}%          atcco2=${LMDZ_CO2}%"             \
-	    namelist_pisces_cfg > namelist_pisces_cfg.tmp
-	IGCM_sys_Mv namelist_pisces_cfg.tmp namelist_pisces_cfg
+	IGCM_debug_Print 1 "Take same CO2 as for LMDZ, in parameter file config.def."
+	# ATM_Update is done before MBG_Update and therefore config.def file contains the correct value for CO2.
+	IGCM_debug_Print 1 'Update atcco2 in namelist_pisces_cfg with same value as for LMDZ'
+	LMDZ_CO2=$( lmdzgrep2 co2_ppm config.def )
+	IGCM_debug_Print 1 "LMDZ_CO2 : ${LMDZ_CO2} "
+	IGCM_comp_modifyNamelist force  namelist_pisces_cfg atcco2 ${LMDZ_CO2}
     fi
 
     ##-- Update namelist_top_cfg and namelist_pisces_cfg
+    IGCM_comp_modifyNamelist blocker  namelist_top_cfg     ln_rsttr   ${TOP_LN_RSTR}
+    IGCM_comp_modifyNamelist blocker  namelist_top_cfg     nn_rsttr   ${TOP_NN_RSTR}
+    IGCM_comp_modifyNamelist blocker  namelist_pisces_cfg  nn_pisdmp  ${OPA_NPDT_YEAR}
+ 
+    # Update iodef.xml
 
-    sed -e "s%${PAT_TOP_LRSTTR}%          ln_rsttr=${TOP_LRSTTR}%"                   \
-        -e "s%${PAT_TOP_NRSTTR}%          nn_rsttr=${TOP_NRSTTR}%"                   \
-        namelist_top_cfg > namelist_top_cfg.tmp
+    if [ X"$( echo ${config_UserChoices_ExpType} | grep CMIP6 )" != "X" ] ; then       
+	VT1D_ENABLE=".FALSE."
+	VT5D_ENABLE=".FALSE."
+	VT1M_ENABLE=".FALSE."
+	VT1Y_ENABLE=".FALSE."
+    fi
 
-    IGCM_sys_Mv namelist_top_cfg.tmp namelist_top_cfg
+    IGCM_debug_Print 1 'Informations into iodef.xml : VT1D_ENABLE VT5D_ENABLE VT1M_ENABLE VT1Y_ENABLE '
+    IGCM_debug_Print 1 ${VT1D_ENABLE}  ${VT5D_ENABLE} ${VT1M_ENABLE} ${VT1Y_ENABLE}
 
-    sed -e "s%${PAT_PIS_LRIVER}%          ln_river=${PISCES_LRIVER}%"                \
-        namelist_pisces_cfg > namelist_pisces_cfg.tmp
-
-    IGCM_sys_Mv namelist_pisces_cfg.tmp namelist_pisces_cfg
-
-
+    IGCM_comp_modifyXmlFile nonblocker file_def_nemo-pisces.xml 1d_pis enabled ${VT1D_ENABLE}
+    IGCM_comp_modifyXmlFile nonblocker file_def_nemo-pisces.xml 5d_pis enabled ${VT5D_ENABLE}
+    IGCM_comp_modifyXmlFile nonblocker file_def_nemo-pisces.xml 1m_pis enabled ${VT1M_ENABLE}
+    IGCM_comp_modifyXmlFile nonblocker file_def_nemo-pisces.xml 1y_pis enabled ${VT1Y_ENABLE}
+   
     IGCM_debug_PopStack "MBG_Update"
 }
